<template>
  <div v-show="isLoaded" class="q-pa-md">
    <div v-if="shoppingCartSize<1" class="column items-center">
      <q-avatar size="72px">
        <img src="../../assets/logo_shopping_cart.svg" />
      </q-avatar>
      <h5 class="text-h5 text-center text-weight-medium">Se pare ca nu ai inca produse in cos.</h5>
      <q-btn
        @click="goHome()"
        flat
        no-caps
        size="lg"
        style="color: #818078"
        label="Vezi produsele"
      />
    </div>
    <div v-else class="row">
      <div class="col-xs-12 col-sm-8 col-8 q-px-lg">
        <div class="order-subtitle">
          <h5 class="text-h5">Shopping cart</h5>
          <h5 class="text-h5">{{shoppingCartSize}} produse</h5>
        </div>
        <q-separator />
        <div class="info-subtitle q-pt-md">
          <p class="text-caption">DETALII PRODUS</p>
          <p class="text-caption">CANTITATE</p>
          <p class="text-caption">PRET</p>
          <p class="text-caption">TOTAL</p>
        </div>
        <div v-for="product in  shoppingCartProducts" :key="product.id" class="row">
          <div class="col-xs-6 col-sm-5 col-5">
            <div class="row">
              <div class="col-6">
                <q-img :src="product.detail.image" style="height: 100px; max-width: 100px" />
              </div>
              <div class="col-6">
                <div class="product-details">
                  <p class="text-subtitle1 text-weight-medium">{{product.detail.name}}</p>
                  <p>Marime: {{product.preference.size}}</p>
                  <p>Culoare: {{product.preference.color}}</p>
                  <q-btn
                    @click="removeFromCart(product)"
                    flat
                    style="color: #818078"
                    label="REMOVE"
                  />
                </div>
              </div>
            </div>
          </div>
          <div class="col-xs-6 col-sm-7 col-7 product-price">
            <p>
              <q-input
                v-model.number="product.quantity"
                type="number"
                :min="1"
                :max="product.preference.quantityAvailable"
                debounce="2000"
                @change="updateQuantity()"
                filled
                style="max-width: 70px"
              />
            </p>
            <p>{{product.detail.price}} RON</p>
            <p>{{totalProductPrice(product.id)}}</p>
          </div>
        </div>
      </div>
      <div class="col-xs-12 col-sm-4 col-4 q-px-lg order-summary">
        <div class="order-subtitle">
          <h5 class="text-h5">Sumar comanda</h5>
        </div>

        <q-separator />
        <div class="order-total q-pt-md">
          <p class="text-caption text-weight-medium">PRODUSE &nbsp; {{shoppingCartSize}}</p>
          <p class="text-caption text-weight-medium">{{totalPurchasePrice}} RON</p>
        </div>
        <div class="column">
          <div class="order-total q-pt-md">
            <p class="text-caption text-weight-medium">TRANSPORT</p>
            <p
              v-if="voucher"
              class="text-primary"
              style="margin:0; vertical-align: middle;"
            >{{(finalValue - deliveryPrice).toFixed(2)}} RON</p>
          </div>
          <p class="text-weight-medium">
            <span class="text-weight-light">Livrare standard:</span>
            {{deliveryPrice}} RON
          </p>
        </div>
        <div class="column q-pt-lg q-pb-md">
          <p class="text-caption text-weight-medium">COD PROMO</p>
          <q-input dense outlined v-model="promoCode" label="Enter your code here" />
        </div>
        <div class="row justify-between">
          <q-btn
            @click="applyPromoCode()"
            class="q-mb-lg"
            unelevated
            color="primary"
            label="APLICA"
          />
          <p v-if="voucher" class="text-primary" style="margin:0; vertical-align: middle;">
            -{{voucher.value}}
            <span v-if="voucher.type === 'percent'">%</span>
            <span v-else>RON</span>
          </p>
        </div>
        <q-separator />
        <div class="column q-pb-md">
          <div class="order-total q-py-md">
            <p class="text-weight-medium">COST TOTAL</p>
            <p class="text-weight-medium">{{finalValue}} RON</p>
          </div>
          <q-btn @click="openCheckout" unelevated color="primary" label="CHECKOUT" />
        </div>
      </div>
    </div>
    <q-btn
      @click="goHome()"
      class="margin-lg"
      no-caps
      flat
      style="color: #818078"
      icon="chevron_left"
      label="Continua cumparaturile"
    />
  </div>
</template>

<script>
//vrttf
export default {
  name: "cart",
  data() {
    return {
      isLoaded: false,
      shoppingCartProducts: [],
      deliveryPrice: 20,
      promoCode: null,
    };
  },
  async mounted() {
    this.$q.loading.show();
    this.$store.dispatch("adminData/loadShoppingCart");
    this.promoCode = this.voucher ? this.voucher.code : null;
    setTimeout(() => {
      this.shoppingCartProducts = JSON.parse(JSON.stringify(this.shoppingCart));
      this.isLoaded = true;
      this.$q.loading.hide();
    }, 1500);
  },
  computed: {
    shoppingCartSize() {
      return this.shoppingCart.reduce(
        (accumulator, item) => accumulator + item.quantity,
        0
      );
    },
    voucher() {
      return this.$store.getters["adminData/getVoucher"];
    },
    shoppingCart() {
      return this.$store.getters["adminData/getShoppingCart"];
    },
    totalPurchasePrice() {
      return this.shoppingCartProducts.reduce(function (accumulator, item) {
        return accumulator + item.quantity * item.detail.price;
      }, 0);
    },

    finalValue() {
      let value = this.totalPurchasePrice;
      if (this.voucher) {
        if (this.voucher.type == "percent")
          value = value - (value * this.voucher.value) / 100;
        else value = value - this.voucher.value;
      }

      return value > 0 ? value + this.deliveryPrice : this.deliveryPrice;
    },
  },

  methods: {
    visualize(item) {},
    updateQuantity() {
      this.$axios
        .put("/api/purchases/cart", {
          items: this.shoppingCartProducts.map((item) => ({
            id: item.preference.id,
            quantity: item.quantity,
          })),
        })
        .then((response) => {
          this.$q.notify({
            message: response.data.message,
            color: "positive",
          });
          this.$store.dispatch("adminData/loadShoppingCart");
        })
        .catch((err) => {
          this.$q.notify({
            color: "negative",
            message: err.response.data.message,
            icon: "report_problem",
          });
        });
    },
    removeFromCart(product) {
      this.$q
        .dialog({
          message: `Are you sure you want to remove ${product.detail.name} from cart?`,
          color: "red-9",
          cancel: true,
          persistent: true,
        })
        .onOk(() => {
          this.shoppingCartProducts.splice(
            this.shoppingCartProducts.indexOf(product),
            1
          );

          this.$axios
            .put("/api/purchases/cart", {
              items: this.shoppingCartProducts.map((item) => ({
                id: item.preference.id,
                quantity: item.quantity,
              })),
            })
            .then((response) => {
              this.$q.notify({
                message: response.data.message,
                color: "positive",
              });
              this.$store.dispatch("adminData/loadShoppingCart");
              setTimeout(() => {
                this.shoppingCartProducts = JSON.parse(
                  JSON.stringify(this.shoppingCart)
                );
              }, 1500);
            })
            .catch(() => {
              this.$q.notify({
                color: "negative",
                message: "Problem",
                icon: "report_problem",
              });
            });
        })
        .onCancel(() => {});
    },
    openCheckout() {
      this.$router.push({ name: "billing" });
    },

    goHome() {
      this.$router.push({ name: "home" });
    },
    totalProductPrice(productId) {
      const foundProduct = this.shoppingCartProducts.find(
        (item) => item.id == productId
      );
      return foundProduct.quantity * foundProduct.detail.price;
    },

    applyPromoCode() {
      if (this.promoCode) {
        this.$axios
          .get("/api/discount/voucher?code=" + this.promoCode)
          .then((response) => {
            this.$q.notify({
              message: "Voucher folosit cu succes",
              color: "positive",
            });
            this.$store.dispatch("adminData/setVoucher", {
              ...response.data,
              code: this.promoCode,
            });
          })
          .catch(() => {
            this.$q.notify({
              color: "negative",
              message: "Problem",
              icon: "report_problem",
            });
          });
      } else
        this.$q.notify({
          message: "Campul nu este completat",
          color: "negative",
        });
    },
  },
};
</script>

<style lang="scss" scoped>
.order-subtitle,
.info-subtitle,
.product-price,
.order-total {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}
.info-subtitle {
  color: #818078;
}
.order-summary {
  background-color: #f2f2f2;
}
</style>
